NTFS_DEVICE= /dev/wd0s2
CFLAGS=	-g -Wall
#CFLAGS=	-O2
LDFLAGS=
#MODFLAGS=	-Wall -D__KERNEL__ -DMODULE -DDEBUG -O2 -DCONFIG_MODVERSIONS
MODFLAGS=	-Wall -D__KERNEL__ -DMODULE -O2 -DCONFIG_MODVERSIONS
COFLAGS= -l

MOUNT=	/usr/src/sbin/mount

PROGRAMS= ntdir ntcat ntdump ntgrep ntchange

all:	$(PROGRAMS) mount_ntfs 44vfs

config.h:
	@echo '#define NTFS_VOLUME "'$(NTFS_DEVICE)'"' > config.h
	@echo '#define GREP_DISPLAY_SIZE 512' >> config.h

ntdump:	dump.o inode.o ntdump.o ntfstools.o dir.o super.o attr.o
	$(CC) -o $@ $>

ntgrep: dump.o inode.o ntgrep.o ntfstools.o dir.o super.o attr.o
	$(CC) -o $@ $>

ntdir:	dir.o inode.o ntdir.o ntfstools.o super.o attr.o
	$(CC) -o $@ $>

ntcat:	dir.o inode.o ntcat.o ntfstools.o super.o attr.o
	$(CC) -o $@ $>

ntchange:	ntchange.o dir.o inode.o ntfstools.o super.o attr.o
	$(CC) -o $@ $>

mount_ntfs:	mount_ntfs.c getmntopts.o
	$(CC) -o $@ $> -I$(MOUNT)

getmntopts.o:	$(MOUNT)/getmntopts.c
	$(CC) -c $> -I$(MOUNT)

44vfs:	always
	cd 44vfs;make;cd ..

clean:
	rm -f core *.o $(PROGRAMS)

install:	all
	install -d /usr/local/bin /lib/modules/$(KVERSION)/fs
	install $(PROGRAMS) /usr/local/bin
	install ntfs.o /lib/modules/$(KVERSION)/fs
	depmod -a

always:

# Who knows to generate a portable makedepend output?
dir.o: dir.c ntfs.h config.h
dump.o: dump.c config.h ntfs.h
inode.o: inode.c ntfs.h config.h
ntcat.o: ntcat.c ntfs.h config.h
ntdir.o: ntdir.c ntfs.h config.h
ntdump.o: ntdump.c ntfs.h config.h
ntfs_fs.o: ntfs_fs.c config.h ntfs.h
ntfstools.o: ntfstools.c config.h ntfs.h
ntgrep.o: ntgrep.c ntfs.h config.h
stack.o: stack.c
super.o: super.c ntfs.h config.h
